PartitionAttributes (Apache Geode 2.0.2)
Description: declaration: package: org.apache.geode.cache, interface: PartitionAttributes

Package org.apache.geode.cache

# Interface PartitionAttributes<K,V>

public interface PartitionAttributes<K,V>
Attributes that define the partitioned character of a Partitioned Region. This interface allows for the discovery of Partitioned Region attributes using `RegionAttributes.getPartitionAttributes()` as well as the configuration of a Partitioned Region using `AttributesFactory.setPartitionAttributes(PartitionAttributes)`. PartitionAttributes are created using the `PartitionAttributesFactory` The default PartitionAttributes can be determined using `PartitionAttributesFactory.create()` with out calling any of its mutator methods e.g. `PartitionAttributesFactory.setLocalMaxMemory(int)` Also see `DataPolicy.PARTITION`.

Since:
  GemFire 5.0

- ## Method Summary

  Modifier and Type
  Method
  Description
  `default RegionAttributesType.PartitionAttributes`
  `convertToConfigPartitionAttributes()`
  `String`
  `getColocatedWith()`
  Returns the colocated PartitionedRegion's name
  `List<FixedPartitionAttributes>`
  `getFixedPartitionAttributes()`
  Returns `FixedPartitionAttributes`'s list of local partitions defined on this Partitioned Region
  `Properties`
  `getGlobalProperties()`
  Deprecated.
  use `getTotalMaxMemory()` and `getTotalNumBuckets()` in GemFire 5.1 and later releases
  `int`
  `getLocalMaxMemory()`
  This method returns the maximum amount of local memory that can be used by the Region.
  `Properties`
  `getLocalProperties()`
  Deprecated.
  use `getLocalMaxMemory()` in GemFire 5.1 and later releases
  `PartitionListener[]`
  `getPartitionListeners()`
  Returns array of PartitionListener{s} configured on this partitioned region
  `PartitionResolver<K,V>`
  `getPartitionResolver()`
  Returns the PartitionResolver set for custom partitioning
  `long`
  `getRecoveryDelay()`
  Returns the delay in milliseconds that existing members will wait before satisfying redundancy after another member crashes.
  `int`
  `getRedundantCopies()`
  The number of Backups for an entry in PartitionedRegion.
  `long`
  `getStartupRecoveryDelay()`
  Returns the delay in milliseconds that a new member will wait before trying to satisfy redundancy of data hosted on other members.
  `long`
  `getTotalMaxMemory()`
  Deprecated.
  since Geode 1.3.0
  `int`
  `getTotalNumBuckets()`
  This method returns total number of buckets for a PartitionedRegion.
  `long`
  `getTotalSize()`
  Deprecated.
  use getTotalMaxMemory() instead

- ## Method Details

  - ### getRedundantCopies

    int getRedundantCopies()
    The number of Backups for an entry in PartitionedRegion. This value should be between 0 and 3 (for a total of 1 to 4 instances of the data). The default value is 0.
    Returns:
      redundantCopies.

  - ### getTotalSize

    @Deprecated long getTotalSize()
    Deprecated.
    use getTotalMaxMemory() instead
    This method returns the maximum total size of the region in megabytes.
    Returns:
      total size in megabytes.

  - ### getTotalMaxMemory

    @Deprecated long getTotalMaxMemory()
    Deprecated.
    since Geode 1.3.0
    This method returns the maximum total size of the region, in megabytes. Default value is Integer.MAX_VALUE.
    Returns:
      maximum size of the partitioned region, in megabytes

  - ### getTotalNumBuckets

    int getTotalNumBuckets()
    This method returns total number of buckets for a PartitionedRegion. Default number of buckets for a PartitionedRegion is 113.
    Returns:
      total number of buckets for a PartitionedRegion.

  - ### getLocalMaxMemory

    int getLocalMaxMemory()
    This method returns the maximum amount of local memory that can be used by the Region. By default, a PartitionedRegion can contribute 90% of the maximum memory allocated to a VM.
    Returns:
      the maximum amount of local memory that can be used by the Region

  - ### getColocatedWith

    String getColocatedWith()
    Returns the colocated PartitionedRegion's name
    Returns:
      the colocated PartitionedRegion's name
    Since:
      GemFire 6.0

  - ### getLocalProperties

    @Deprecated Properties getLocalProperties()
    Deprecated.
    use `getLocalMaxMemory()` in GemFire 5.1 and later releases
    This method returns local properties. There are currently no local properties defined that are not also deprecated.
    Returns:
      local properties

  - ### getGlobalProperties

    @Deprecated Properties getGlobalProperties()
    Deprecated.
    use `getTotalMaxMemory()` and `getTotalNumBuckets()` in GemFire 5.1 and later releases
    This method returns global properties. There are currently no global properties defined that are not also deprecated.
    Returns:
      global properties

  - ### getPartitionResolver

    PartitionResolver<K,V> getPartitionResolver()
    Returns the PartitionResolver set for custom partitioning
    Returns:
      `PartitionResolver` for the PartitionedRegion
    Since:
      GemFire 6.0

  - ### getRecoveryDelay

    long getRecoveryDelay()
    Returns the delay in milliseconds that existing members will wait before satisfying redundancy after another member crashes. Default value of recoveryDelay is -1 which indicates that redundancy won't be recovered if a member crashes.
    Returns:
      the delay in milliseconds that existing members will wait before satisfying redundancy after another member crashes
    Since:
      GemFire 6.0

  - ### getStartupRecoveryDelay

    long getStartupRecoveryDelay()
    Returns the delay in milliseconds that a new member will wait before trying to satisfy redundancy of data hosted on other members. Default value is 0 which is to recover redundancy immediately when a new member is added.
    Returns:
      the delay in milliseconds that a new member will wait before trying to satisfy redundancy of data hosted on other members
    Since:
      GemFire 6.0

  - ### getPartitionListeners

    PartitionListener[] getPartitionListeners()
    Returns array of PartitionListener{s} configured on this partitioned region
    Returns:
      PartitionListener configured on this partitioned region
    Since:
      GemFire 6.5
    See Also:
      - `PartitionListener`

  - ### getFixedPartitionAttributes

    List<FixedPartitionAttributes> getFixedPartitionAttributes()
    Returns `FixedPartitionAttributes`'s list of local partitions defined on this Partitioned Region
    Returns:
      `FixedPartitionAttributes`'s list of local partitions defined on this Partitioned Region
    Since:
      GemFire 6.6

  - ### convertToConfigPartitionAttributes

    default RegionAttributesType.PartitionAttributes convertToConfigPartitionAttributes()